
import { BonBuffer } from "../../net/serialization/bon";
import { addToMeta, removeFromMeta, Struct, notifyModify, StructMgr, structMgr} from "../../net/serialization/struct_mgr";
import { StructInfo, Type, FieldInfo, EnumType, EnumInfo} from "../../net/serialization/sinfo";

export class OK_I extends Struct {

    value: number;
	static _$info =  new StructInfo("pi_utils/net/rpc_r.OK_I",389462479, null, [new FieldInfo("value", 
new EnumType( Type.Usize ), null) ]);





	
	static bonType(): number {
		return OK_I._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): OK_I {
		let o;
		o = new OK_I();

		o.value = bb.readInt();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeInt(this.value);
        
		return bb;
	}
    }
    structMgr.register(OK_I._$info.name_hash, OK_I, OK_I._$info.name);


export class OK_S extends Struct {

    value: string;
	static _$info =  new StructInfo("pi_utils/net/rpc_r.OK_S",840976468, null, [new FieldInfo("value", 
new EnumType( Type.Str ), null) ]);





	
	static bonType(): number {
		return OK_S._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): OK_S {
		let o;
		o = new OK_S();

		o.value = bb.readUtf8();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.value);
        
		return bb;
	}
    }
    structMgr.register(OK_S._$info.name_hash, OK_S, OK_S._$info.name);


export class Req extends Struct {

    path: string;
	static _$info =  new StructInfo("pi_utils/net/rpc_r.Req",3436444407, null, [new FieldInfo("path", 
new EnumType( Type.Str ), null) ]);





	
	static bonType(): number {
		return Req._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): Req {
		let o;
		o = new Req();

		o.path = bb.readUtf8();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.path);
        
		return bb;
	}
    }
    structMgr.register(Req._$info.name_hash, Req, Req._$info.name);


export class Error extends Struct {

    code: number;
    info: string;
	static _$info =  new StructInfo("pi_utils/net/rpc_r.Error",146780891, null, [new FieldInfo("code", 
new EnumType( Type.Usize ), null), new FieldInfo("info", 
new EnumType( Type.Str ), null) ]);





	
	static bonType(): number {
		return Error._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): Error {
		let o;
		o = new Error();

		o.code = bb.readInt();
		o.info = bb.readUtf8();
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeInt(this.code);
                
        bb.writeUtf8(this.info);
        
		return bb;
	}
    }
    structMgr.register(Error._$info.name_hash, Error, Error._$info.name);


export class Ok extends Struct {

	static _$info =  new StructInfo("pi_utils/net/rpc_r.Ok",4179775333, null, [ ]);





	
	static bonType(): number {
		return Ok._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): Ok {
		let o;
		o = new Ok();

		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {
		return bb;
	}
    }
    structMgr.register(Ok._$info.name_hash, Ok, Ok._$info.name);

