import { BonBuffer } from "../../net/serialization/bon";
import { addToMeta, removeFromMeta, Struct, notifyModify, StructMgr, structMgr} from "../../net/serialization/struct_mgr";
import { StructInfo, Type, FieldInfo, EnumType, EnumInfo} from "../../net/serialization/sinfo";
export class User extends Struct {

    user: string;
    auths: Map<number,number>;
	static _$info =  new StructInfo("management_page/server/rpc/user.User",86776789, null, [new FieldInfo("user", 
new EnumType( Type.Str ), null), new FieldInfo("auths", 
new EnumType( Type.Map, [
new EnumType( Type.U32 ), 
new EnumType( Type.U8 )] ), null) ]);





	
	static bonType(): number {
		return User._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): User {
		let o;
		o = new User();

		o.user = bb.readUtf8();
		o.auths = bb.readMap(() => {
	return [bb.readInt(), bb.readInt()];
});
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeUtf8(this.user);
                
        bb.writeMap(this.auths, (k, v) => {    
            bb.writeInt(k);
                
            bb.writeInt(v);
            
        });
        
		return bb;
	}
    }
    structMgr.register(User._$info.name_hash, User, User._$info.name);


export class Users extends Struct {

    list: Array<User>;
	static _$info =  new StructInfo("management_page/server/rpc/user.Users",1462627910, null, [new FieldInfo("list", 
new EnumType( Type.Arr, 
new EnumType(Type.Struct, User._$info ) ), null) ]);





	
	static bonType(): number {
		return Users._$info.name_hash;
	}

	static bonDecode(bb:BonBuffer): Users {
		let o;
		o = new Users();

		o.list = bb.readArray(() => {
	return      (<any>o)._$EnumTypeMap?(<any>o)._$EnumTypeMap(o.list):User.bonDecode(bb);
})
;
		return o
	}


	bonEncode(bb:BonBuffer): BonBuffer {        
        bb.writeArray(this.list, (el) => {    el.bonEncode(bb);
            
        });
        
		return bb;
	}
    }
    structMgr.register(Users._$info.name_hash, Users, Users._$info.name);

