import { PanelPlugin } from '@grafana/data';
import { SimpleOptions } from './types';
import { ProxyPanel } from './SimplePanel';

export const plugin = new PanelPlugin<SimpleOptions>(ProxyPanel).setPanelOptions(builder => {
    return builder
        .addTextInput({
            path: 'text',
            name: 'Simple text option',
            description: 'Description of panel option',
            defaultValue: 'Default value of text input option',
        });
});
